<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<title>Shokado Web Sharing for Bento - Form View</title>
<style type="text/css">
body {background-color:#f9f9f9;	font-family:Helvetica, Arial, sans-serif; font-size:11px; margin-left:1px;margin-top:1px;}
th {background-color:#e9e9e9; text-align:left;	font-family:Helvetica, Arial, sans-serif; font-size:11px;}
td {vertical-align:top;font-family:Helvetica, Arial, sans-serif;font-size:11px;}
table {border-collapse:collapse;}
#libname {font-family:ComicSansMS, Helvetica, Arial, sans-serif;padding-top:2px;padding-left:4px;height:34px;margin-bottom:2px;background-color:#616367;color:white;font-size:24px;vertical-align:middle;} 

</style>
<script language=javascript>
function switchform() {
	var loc = self.location.toString();
	var selform=document.getElementById('selForm').options;
	var selectedForm = selform[selform.selectedIndex].value;

	if (loc.indexOf("&formid")>0)
	{
		loc = loc.substring(0,loc.indexOf('&formid'));
	}
	loc = loc+ '&formid='+selectedForm;
	self.location.href = loc;
}
</script>
</head>
<body>
<?php
/*
This file is part of Shokado Web Sharing Tool for Bento.

Shokado Web Sharing Tool for Bento is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Shokado Web Sharing Tool for Bento is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with Shokado Web Sharing Tool for Bento.  If not, see <http://www.gnu.org/licenses/>.
*/

include ("config.php");

//Connect to the database, try to select a table
$db = new PDO($bentoDB,0666,&$error);
$checkdbresult = $db->query("PRAGMA table_info(gn_domain)");
if ($row = $checkdbresult->fetch(PDO::FETCH_ASSOC)===false) {
	echo "Unable to connect!";
	exit;
}
//Converts a CoreData timestamp to the local date
function phpDate($cdDate)
{
 	if (strlen($cdDate)==0) return "<span style=\"display:none\">00/00/0000</span>";
 	
  	$testDate  = mktime(0,0,0,1,1,2001);
   	$gmtoffset = date('Z');
  	$addseconds = $cdDate + $testDate + $gmtoffset;
  	$hrDate = date("m/d/Y",$addseconds);
  	
  	return $hrDate; 
}

//Converts a CoreData timestamp to the local date
function phpDateTime($cdDate)
{
 	if (strlen($cdDate)==0) return "<span style=\"display:none\">00/00/0000</span>";
 	
  	$testDate  = mktime(0,0,0,1,1,2001);
   	$gmtoffset = date('Z');
  	$addseconds = $cdDate + $testDate + $gmtoffset;
  	$hrDate = date("m/d/Y h:i A",$addseconds);
  	
  	return $hrDate; 
}
//Converts a checkbox field
function phpCB($cbVal)
{
	$cbstr = "<input disabled type=checkbox";
 	if ($cbVal=="1.0") $cbstr.=" checked";
 	$cbstr.=">";
 	
  	return $cbstr;
}

//Get related records
function getRelatedRecords($fieldID) {

	$relResults="&nbsp;";
	
	global $db;
	global $recordid;
	global $libName;
	global $libID;
	$sql = "SELECT M_RelationshipDescription.gn_tablename, M_RelationshipDescription.gn_inverseName, M_RelationshipDescription.gn_name,M_RelationshipDescription.gn_colName,
	M_RelationshipDescription.gn_destination, M_RelationshipDescription_1.gn_colName as colName_1 
	FROM gn_field INNER JOIN gn_setting ON gn_field.gn_settings = gn_setting.gn_group INNER JOIN M_RelationshipDescription ON gn_setting.gn_textSetting = M_RelationshipDescription.gn_inverseName
	INNER JOIN M_RelationshipDescription AS M_RelationshipDescription_1 ON M_RelationshipDescription.gn_name = M_RelationshipDescription_1.gn_inverseName 
	WHERE gn_field.gnpk=".$fieldID." AND gn_setting.gn_key=\"relationshipName\"";
	
	$inverseResult = $db->query($sql);
	$irrow = $inverseResult->fetch(PDO::FETCH_ASSOC);
	
	$inversetableName = $irrow["gn_tablename"];
	$inverseName = $irrow["gn_inverseName"];
	$colName  = $irrow["gn_name"];
	$inverseColName  = $irrow["gn_colName"];
	$dest = "gn_".$irrow["gn_destination"];
	$colName1  = $irrow["colName_1"];
	
	
	//get fields
	$sql="SELECT gn_sourceitem.gn_domain
	FROM gn_field INNER JOIN gn_setting ON gn_field.gn_settings = gn_setting.gn_group INNER JOIN gn_sourceitem ON gn_setting.gn_textSetting = gn_sourceitem.gnguid
	WHERE gn_field.gnpk=$fieldID AND gn_setting.gn_key=\"targetSourceItemUID\"";
	$domainResult = $db->query($sql);
	$drow = $domainResult->fetch(PDO::FETCH_ASSOC);
	
	$domainID = $drow["gn_domain"];
	

	
	$sql="SELECT gn_field_1.gn_label, gn_field_1.gn_name, gn_field_1.gn_typeName, gn_field_1.gnpk
	FROM gn_field INNER JOIN gn_fielddisplay ON gn_field.gnpk = gn_fielddisplay.gn_field INNER JOIN gn_displaycontext ON gn_fielddisplay.gn_displayContext = gn_displaycontext.gnpk INNER JOIN gn_domain ON gn_fielddisplay.gn_displayContext = gn_domain.gn_displayContext INNER JOIN gn_fielddisplay AS gn_fielddisplay_1 ON gn_domain.gn_displayContext = gn_fielddisplay_1.gn_displayContext INNER JOIN gn_field AS gn_field_1 ON gn_fielddisplay_1.gn_field = gn_field_1.gnpk INNER JOIN gn_tablecolumn ON gn_fielddisplay_1.gnpk = gn_tablecolumn.gn_fieldDisplay
	WHERE gn_field.gnpk=$fieldID AND gn_tablecolumn.gn_visible=1 AND gn_domain.gnpk=$domainID";
	
	$fresult = $db->query($sql); 
	$c=0;
	while($row = $fresult->fetch(PDO::FETCH_ASSOC)) {
		$flabel = $row["gn_label"];
		$fieldArray[$flabel]=array("name"=>$row["gn_name"],"type"=>$row["gn_typeName"]);
	
	}
	
	//Get related records
	$sql = "SELECT $dest.*
	FROM $dest INNER JOIN $inversetableName ON $dest.gnpk = $inversetableName.$colName1
	WHERE $inversetableName.$inverseColName=$recordid";

	$data = "&nbsp;";
	if ($itemresult = $db->query($sql)){; 
		//Write record information
		$rcount=0;
		while($itemrow = $itemresult->fetch(PDO::FETCH_ASSOC)) {
			if ($rcount==0) {
				$data = "\n<table border=1 width=100%>\n<tr>";
				foreach ($fieldArray as $k=>$v) {
					$data.="<th>".$k."</th>";
				}
				$data .="</tr>\n";
			}
			$data .="<tr>";
			
			foreach ($fieldArray as $k=>$v) {
				$colname= "gn_".$v["name"];
		
				$coltype = $v["type"];
				$collabel = $v["label"];
				$colval = $itemrow[$colname];
				
				switch ($coltype) {
					case "com.filemaker.bento.field.core.date":
						$colval=phpDate($colval);
						break;
					case "com.filemaker.bento.field.private.timestamp.dateCreated":
						$colval=phpDateTime($colval);
						break;
					case "com.filemaker.bento.field.private.timestamp.dateModified":
						$colval=phpDateTime($colval);
						break;
					case "com.filemaker.bento.field.core.checkbox":
						$colval=phpCB($colval);
						break;
					default:
						break;
				}
				
				if (strlen($colval)==0) $colval="&nbsp;";
				$data .= "<td>".$colval."</td>";
			}
			$data .="</tr>\n";
			$rcount++;
		}
		if ($rcount>0) $data .="</table>";
	
	}
	
	return $data;
}

//Get a media item (images only)
function getMediaItem($mediaID)
{
	
	global $db;
	global $bentoDB;
	
	$fileName = str_replace("bentomedia://","",$mediaID);
	
	$bentoMediaDir  = str_replace("sqlite:","",str_replace("Database","Media/",$bentoDB));
	$mediaFile = str_replace("bentomedia://",$bentoMediaDir,$mediaID);
	
	
	$errorMsg = $mediaID." (Cannot display media)";
	
	//Get the Shokado media directory
	$mediaDirectory = getMediaDirectory();
	if (strlen($mediaDirectory)==0) return $errorMsg;
	
	
	
	//Replace space characters and localhost info
	$fileSource=$mediaFile;
	$fileDest = getcwd()."/Media/".$fileName;
		
	//Copy the file from its location to the web media directory
	if (copy($fileSource, $fileDest)===false) return $errorMsg;
	
	$imageTag = "<img style=\"max-width:400px; max-height:300px;\" src=Media/".$fileName.">"; 
	
	return $imageTag;
	 
}

//Get a media link
function getMediaLink($mediaID)
{
	
	global $db;
	global $bentoDB;
	
	$fileName = str_replace("bentomedia://","",$mediaID);
	
	$bentoMediaDir  = str_replace("sqlite:","",str_replace("Database","Media/",$bentoDB));
	$mediaFile = str_replace("bentomedia://",$bentoMediaDir,$mediaID);
	
	
	$errorMsg = $mediaID." (Cannot display media)";
	
	//Get the Shokado media directory
	$mediaDirectory = getMediaDirectory();
	if (strlen($mediaDirectory)==0) return $errorMsg;
	
	
	
	//Replace space characters and localhost info
	$fileSource=$mediaFile;
	$fileDest = getcwd()."/Media/".$fileName;
		
	//Copy the file from its location to the web media directory
	if (copy($fileSource, $fileDest)===false) return $errorMsg;
	
	$imageTag = "<a target=_blank href=Media/".$fileName.">$fileName</a>"; 
	
	return $imageTag;
	 
}

//Gets the Shokado media directory or creates if needed
function getMediaDirectory() {
	$baseDir = getcwd();
	$mediaDir = $baseDir ."/Media";
	if (is_dir($mediaDir)) return $mediaDir;
	if (mkdir($mediaDir)) return $mediaDir;
	return "";
}

//Set defaults
$libName = "";
$libID = -1;
$recordid = -1;
$collID = -1;
$uformID = -1;

//See if passed anything on the post
if (isset($_GET["lib"])) {
	$libName = $_GET["lib"];
}
if (isset($_GET["id"])) {
	$recordid = $_GET["id"];
}
if (isset($_GET["libid"])) {
	$libID = $_GET["libid"];
}
if (isset($_GET["collid"])) {
	$collID = $_GET["collid"];
}

if (isset($_GET["formid"])) {
	$uformID = $_GET["formid"];
}
//Make sure we have good information
if (strlen($libName)==0 | $recordid==-1 | $libid==-1) {
	echo "Unable to find record!";
	exit;
}

//Get the form(s)
$entid=($collID == -1 ? $libID : $collID);
$fsql = "SELECT gn_form.gn_label, gn_form.gnpk
	FROM gn_form INNER JOIN gn_displaycontext ON gn_form.gn_displayContext = gn_displaycontext.gnpk
	INNER JOIN gn_domain ON gn_displaycontext.gn_sourceDomain = gn_domain.gnpk
	WHERE gn_domain.gn_sourceItem=".$entid." ORDER BY gn_form.gn_order";
$fresult = $db->query($fsql);
$fcount=0;
$fdisp = "<select name=selForm id=selForm onchange=switchform()>";
while($frow = $fresult->fetch(PDO::FETCH_ASSOC)) {
	$fcount++;
	$formID = $frow["gnpk"];

	$sel="";
	$formLabel = $frow["gn_label"];
	
	if ($uformID == $formID)
	{
		$sel = " selected";
		$selectedFormID = $formID;
	}
	else if ($uformID==-1 & $fcount==1) {
		$sel = " selected";
		$selectedFormID = $formID;
	}
		
	$formArray[$formID]=$formLabel;
	$fdisp.="<option $sel value=$formID>$formLabel</option>";
}
$fdisp .="</select>";
$uformID=$selectedFormID;
//Get all fields for the form
$fldsql="SELECT gn_field.gnpk, gn_field.gn_name, gn_field.gn_label, gn_field.gn_typeName FROM gn_form INNER JOIN gn_formcell ON gn_form.gnpk = gn_formcell.gn_formEntity INNER JOIN gn_fielddisplay ON gn_formcell.gn_fieldDisplay = gn_fielddisplay.gnpk INNER JOIN gn_field ON gn_fielddisplay.gn_field = gn_field.gnpk WHERE gn_form.gnpk=".$uformID;

$result = $db->query($fldsql); 
$twoColumns = false;
echo "<div id=\"libname\">Form View $fdisp</div>";

while($row = $result->fetch(PDO::FETCH_ASSOC)) {
	$arrayKey=$row["gnpk"];
	$fieldArray[$arrayKey]=array("pk"=>$arrayKey, "name"=>$row["gn_name"],"label"=>$row["gn_label"],"type"=>$row["gn_typeName"]);
	if ($row["gn_typeName"]=="com.filemaker.bento.field.layout.columnDivider") {
		$twoColumns="width=50%";
	}
}
echo "<table cellpadding=1 cellspacing=0 style=\"border-style:solid; border-width: 1px; border-color:black\" width=100%><tr><td $twoColumns>";
echo "<table  border=1 cellspacing=3 cellpadding=3>\r";

//Get records
$sql = "SELECT * FROM gn_".$libName." WHERE gnpk=".$recordid;

$result = $db->query($sql); 
//Write record information
$row = $result->fetch(PDO::FETCH_ASSOC);
foreach ($fieldArray as $k=>$v) {
	$colname= "gn_".$v["name"];
	
	$coltype = $v["type"];
	$collabel = $v["label"];
	$colval = $row[$colname];
	switch ($coltype) {
	case "com.filemaker.bento.field.core.date":
		$colval=phpDate($colval);
		break;
	case "com.filemaker.bento.field.private.timestamp.dateCreated":
		$colval=phpDateTime($colval);
		break;
	case "com.filemaker.bento.field.private.timestamp.dateModified":
		$colval=phpDateTime($colval);
		break;
	case "com.filemaker.bento.field.core.checkbox":
		$colval=phpCB($colval);
		break;
	case "com.filemaker.bento.field.table.relatedrecords":
		$colval=getRelatedRecords($v["pk"]);
		break;
	case "com.filemaker.bento.field.core.media":
		if (strlen($colval)>0) {
			$zf = $row["gn_mediaType"];
			if ($zf=="Image" |  $v["name"]=="fldPicture") {
				$colval = getMediaItem($colval);
			}
			else {
				$colval = getMediaLink($colval);
			}
		}
		break;
	case "com.filemaker.bento.field.layout.horizontalSeparator":
		$collabel="&nbsp;";
		$colval="&nbsp;";
		break;
	default:
		break;
	}
	if (strlen($colval)==0) $colval="&nbsp;";
	
	if ($coltype=="com.filemaker.bento.field.layout.columnDivider") {
		echo "</table></td><td><table class=\"sortable\" border=1 cellspacing=3 cellpadding=3>";
	}
	else {
		echo "<tr><th valign=top nowrap>".$collabel."</th><td width=100%>".$colval."</td></tr>";
	}
}
echo "</table></td></tr></table>";
?>
<div align=center><input type="button" value="Close" onclick="self.close()"></div>
</body>
</html>